<template>
  <div>
    <rui-tag v-for="tag in list" :key="tag" :tag="tag" />
  </div>
</template>

<script>
import RuiTag from './Tag.vue'

/**
 * Displays a list of tags with ability to merge similar ones.
 *
 * @preset Default { "props": { "tags": [ "a tag", "a::composed::tag", "color::blue", "color::red"]}}
 * @propsGroup Display [group]
 * @propsGroup Content [tags]
 */
export default {
  name: 'RuiTags',
  components: { RuiTag },
  props: {
    /** Tags list */
    tags: { required: true, type: Array },
    /** Whether to group similar tags */
    group: { required: false, type: Boolean, default: true },
  },
  computed: {
    list () {
      if (!this.$props.group) return this.tags

      const list = {}

      this.$props.tags.forEach((tag) => {
        const chunks = tag.split('::')
        const key = chunks.shift()

        if (!list[key]) list[key] = []

        if (chunks.length > 0) list[key].push(chunks.join('::'))
      })

      return Object.keys(list).sort((a, b) => a.localeCompare(b)).map(key => list[key].length > 0 ? `${key}::${list[key].join(' • ')}` : key)
    },
  },
}
</script>
